variables:
  DOCKER_DRIVER: overlay2

  # explicit tag to be used within pipeline
  BUILD_IMAGE_NAME: "$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA"

  # we also publish a floating tag to simplify manual testing
  BUILD_IMAGE_NAME_LATEST: "$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:latest"

  DOCKER_VERSION: 20.10.1

  CI_APPLICATION_TAG: "$CI_COMMIT_SHA"
  CI_APPLICATION_REPOSITORY: "$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG/$CI_JOB_NAME"

stages:
  - build
  - test
  - test-build
  - test-run
  - deploy

build:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  before_script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
  script:
    - /kaniko/executor --context $CI_PROJECT_DIR 
        --build-arg DOCKER_VERSION="$DOCKER_VERSION" 
        --dockerfile $CI_PROJECT_DIR/Dockerfile 
        --destination "$BUILD_IMAGE_NAME" 
        --destination "$BUILD_IMAGE_NAME_LATEST"

# deploy:tag:
#   stage: deploy
#   image: "docker:${DOCKER_VERSION}"
#   services:
#     - "docker:${DOCKER_VERSION}-dind"
#   script:
#     - 'echo ${CI_JOB_TOKEN} | docker login --password-stdin -u $CI_REGISTRY_USER $CI_REGISTRY'
#     - export ci_image="${CI_REGISTRY_IMAGE}"
#     - export ci_image_tag=${CI_COMMIT_TAG:-$CI_COMMIT_SHORT_SHA}
#     - echo "Using tag $ci_image_tag for image"
#     - docker pull "$BUILD_IMAGE_NAME"
#     - docker tag "$BUILD_IMAGE_NAME" $ci_image:latest
#     - docker tag "$BUILD_IMAGE_NAME" $ci_image:$ci_image_tag
#     - docker push $ci_image:latest
#     - docker push $ci_image:$ci_image_tag
#   only:
#     - tags


